/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.30 Revision 1.66
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.30 2006/09/07 18:34:00 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.66 2009/02/23 23:46:31 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
38# 38#
39# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
41# 41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44# 44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
48 48
58# all patches which ending on diff or patch in this DIR will automatically applied 58# all patches which ending on diff or patch in this DIR will automatically applied
59# 59#
60 60
61inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
62 62
63IUSE="debug" 63IUSE=""
64 64
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
67VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77
78DEPEND="${COMMON_DEPEND}
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
78 82
79 83# New method of storing plugindb
80# this code is from linux-mod.eclass 84# Called from src_install
81update_vdrplugindb() { 85# file maintained by normal portage-methods
86create_plugindb_file() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 87 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
83 88 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102
103vdr-plugin_pkg_setup() {
104 # -fPIC is needed for shared objects on some platforms (amd64 and others)
105 append-flags -fPIC
106 use debug && append-flags -g
107
108 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111
112 # transition to /usr/share/... will need new vdr-scripts version stable
113 VDR_RC_DIR="/usr/lib/vdr/rcscript"
114
115 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include"
118
119
120 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
121 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
122 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
123
124 einfo "Building ${PF} against vdr-${VDRVERSION}"
125 einfo "APIVERSION: ${APIVERSION}"
126}
127
128vdr-plugin_src_unpack() {
129 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
130 eerror "Wrong use of vdr-plugin.eclass."
131 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
132 echo
133 eerror "Please report this at bugs.gentoo.org."
134 die "vdr-plugin_pkg_setup not called!"
135 fi
136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
137
138 while [ "$1" ]; do
139
140 case "$1" in
141 unpack)
142 base_src_unpack
143 ;;
144 patchmakefile)
145 if ! cd ${S}; then
146 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
147 ewarn "Perhaps you find one among these:"
148 cd "${WORKDIR}"
149 einfo "$(/bin/ls -1 ${WORKDIR})"
150 die "Could not change to plugin-source-directory!"
151 fi
152
153 einfo "Patching Makefile"
154 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
155 cp Makefile Makefile.orig
156
157 sed -i Makefile \
158 -e '1i\#Makefile was patched by vdr-plugin.eclass'
159
160 ebegin " Setting Pathes"
161 sed -i Makefile \
162 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
163 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
164 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
165 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
166 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
167 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
168 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
169 eend $?
170
171 ebegin " Converting to APIVERSION"
172 sed -i Makefile \
173 -e 's:^APIVERSION = :APIVERSION ?= :' \
174 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
175 -e '2i\APIVERSION = '"${APIVERSION}"
176 eend $?
177
178 ebegin " Correcting CXXFLAGS"
179 sed -i Makefile \
180 -e 's:^CXXFLAGS:#CXXFLAGS:'
181 eend $?
182
183 ebegin " Disabling file stripping"
184 sed -i Makefile \
185 -e '/@.*strip/d' \
186 -e '/strip \$(LIBDIR)\/\$@/d' \
187 -e '/^STRIP =/d' \
188 -e '/@.*\$(STRIP)/d'
189 eend $?
190 ;;
191 add_local_patch)
192 cd ${S}
193 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
194 echo
195 einfo "Applying local patches"
196 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
197 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
198 done
199 fi
200 ;;
201 esac
202
203 shift
204 done
205}
206
207vdr-plugin_copy_source_tree() {
208 cp -r ${S} ${T}/source-tree
209 cd ${T}/source-tree
210 mv Makefile.orig Makefile
211 sed -i Makefile \
212 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
213 -e 's:^CXXFLAGS:#CXXFLAGS:' \
214 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
215 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
216}
217
218vdr-plugin_install_source_tree() {
219 einfo "Installing sources"
220 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
221 insinto ${destdir}-${PV}
222 doins -r ${T}/source-tree/*
223
224 dosym ${VDRPLUGIN}-${PV} ${destdir}
225}
226
227vdr-plugin_src_compile() {
228 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
229
230 while [ "$1" ]; do
231
232 case "$1" in
233 prepare)
234 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
235 ;;
236 compile)
237 cd ${S}
238
239 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
240 ;;
241 esac
242
243 shift
244 done
245}
246
247vdr-plugin_src_install() {
248 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
249 cd ${S}
250
251 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
252 local mname=${P}-Makefile
253 cp Makefile ${mname}.patched
254 cp Makefile.orig ${mname}.before
255
256 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
257
258 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
259 doins ${mname}.diff
260
261 insinto "/usr/share/vdr/maintainer-data/makefile-before"
262 doins ${mname}.before
263
264 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
265 doins ${mname}.patched
266
267 fi
268
269 insinto "${VDR_PLUGIN_DIR}" 89 insinto "${NEW_VDRPLUGINDB_DIR}"
270 doins libvdr-*.so.*
271 local docfile
272 for docfile in README* HISTORY CHANGELOG; do
273 [[ -f ${docfile} ]] && dodoc ${docfile}
274 done
275 90
276 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 91# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
277 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 92# cat <<-EOT > "${D}/${DB_FILE}"
93# VDRPLUGIN_DB=1
94# CREATOR=ECLASS
95# EBUILD=${CATEGORY}/${PN}
96# EBUILD_V=${PVR}
97# EOT
98 {
99 echo "VDRPLUGIN_DB=1"
100 echo "CREATOR=ECLASS"
101 echo "EBUILD=${CATEGORY}/${PN}"
102 echo "EBUILD_V=${PVR}"
103 echo "PLUGINS=\"$@\""
104 } > "${D}/${DB_FILE}"
105}
278 106
279 if [[ -n ${VDR_CONFD_FILE} ]]; then 107# Delete files created outside of vdr-plugin.eclass
280 insinto /etc/conf.d 108# vdrplugin-rebuild.ebuild converted plugindb and files are
281 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 109# not deleted by portage itself - should only be needed as
282 fi 110# long as not every system has switched over to
111# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
112delete_orphan_plugindb_file() {
113 #elog Testing for orphaned plugindb file
114 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
115 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
283 116
117 # file exists
118 [[ -f ${DB_FILE} ]] || return
284 119
285 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 120 # will portage handle the file itself
286 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 121 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
287 122 #elog file owned by eclass - don't touch it
288 if [[ -n ${VDR_RCADDON_FILE} ]]; then 123 return
289 insinto "${VDR_RC_DIR}"
290 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
291 fi 124 fi
292 125
126 elog "Removing orphaned plugindb-file."
127 elog "\t#rm ${DB_FILE}"
128 rm "${DB_FILE}"
129}
293 130
294 131
295 insinto ${VDR_CHECKSUM_DIR} 132create_header_checksum_file()
133{
134 # Danger: Not using $ROOT here, as compile will also not use it !!!
135 # If vdr in $ROOT and / differ, plugins will not run anyway
136
137 local CHKSUM="header-md5-vdr"
138
296 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 139 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
297 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 140 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
141 elif type -p md5sum >/dev/null 2>&1; then
142 (
143 cd "${VDR_INCLUDE_DIR}"
144 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
145 ) > "${CHKSUM}"
298 else 146 else
299 if which md5sum >/dev/null 2>&1; then 147 die "Could not create md5 checksum of headers"
300 cd ${S}
301 (
302 cd ${ROOT}${VDR_INCLUDE_DIR}
303 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
304 ) > header-md5-${PN}
305 doins header-md5-${PN}
306 fi 148 fi
307 fi
308}
309 149
310vdr-plugin_pkg_postinst() { 150 insinto "${VDR_CHECKSUM_DIR}"
311 update_vdrplugindb 151 local p_name
312 einfo 152 for p_name; do
313 einfo "The vdr plugin ${VDRPLUGIN} has now been installed." 153 newins "${CHKSUM}" "header-md5-${p_name}"
314 einfo "To activate execute the following command:"
315 einfo
316 einfo " emerge --config ${PN}"
317 einfo
318 if [[ -n "${VDR_CONFD_FILE}" ]]; then
319 einfo "And have a look at the config-file"
320 einfo "/etc/conf.d/vdr.${VDRPLUGIN}"
321 einfo
322 fi
323}
324
325vdr-plugin_pkg_postrm() {
326 remove_vdrplugindb
327}
328
329vdr-plugin_pkg_config_final() {
330 diff ${conf_orig} ${conf}
331 rm ${conf_orig}
332}
333
334vdr-plugin_pkg_config() {
335 if [[ -z "${INSTALLPLUGIN}" ]]; then
336 INSTALLPLUGIN="${VDRPLUGIN}"
337 fi
338 # First test if plugin is already inside PLUGINS
339 local conf=/etc/conf.d/vdr
340 conf_orig=${conf}.before_emerge_config
341 cp ${conf} ${conf_orig}
342
343 einfo "Reading ${conf}"
344 if ! grep -q "^PLUGINS=" ${conf}; then
345 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
346 if [[ -n "${LINE}" ]]; then
347 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
348 else
349 echo 'PLUGINS=""' >> ${conf}
350 fi
351 unset LINE
352 fi
353
354 unset PLUGINS
355 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
356
357 active=0
358 for p in ${PLUGINS}; do
359 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
360 active=1
361 break;
362 fi
363 done 154 done
364
365 if [[ "${active}" == "1" ]]; then
366 einfo "${INSTALLPLUGIN} already activated"
367 echo
368 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
369 if [[ "${answer}" != "yes" ]]; then
370 einfo "aborted"
371 return
372 fi
373 einfo "Removing ${INSTALLPLUGIN} from active plugins."
374 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
375 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
376 -e ${LINE}'s/ \( \)*/ /g' \
377 -e ${LINE}'s/ "/"/g' \
378 -e ${LINE}'s/" /"/g'
379
380 vdr-plugin_pkg_config_final
381 return
382 fi
383
384
385 einfo "Adding ${INSTALLPLUGIN} to active plugins."
386 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
387 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
388 -e ${LINE}'s/ \( \)*/ /g' \
389 -e ${LINE}'s/ "/"/g' \
390 -e ${LINE}'s/" /"/g'
391
392 vdr-plugin_pkg_config_final
393} 155}
394 156
395fix_vdr_libsi_include() 157fix_vdr_libsi_include()
396{ 158{
397 einfo "Fixing include of libsi-headers" 159 einfo "Fixing include of libsi-headers"
401 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 163 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
402 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 164 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
403 done 165 done
404} 166}
405 167
168vdr_patchmakefile() {
169 einfo "Patching Makefile"
170 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
171 cp Makefile "${WORKDIR}"/Makefile.before
172
173 # plugin makefiles use VDRDIR in strange ways
174 # assumptions:
175 # 1. $(VDRDIR) contains Make.config
176 # 2. $(VDRDIR) contains config.h
177 # 3. $(VDRDIR)/include/vdr contains the headers
178 # 4. $(VDRDIR) contains main vdr Makefile
179 # 5. $(VDRDIR)/locale exists
180 # 6. $(VDRDIR) allows to access vdr source files
181 #
182 # We only have one directory (for now /usr/include/vdr),
183 # that contains vdr-headers and Make.config.
184 # To satisfy 1-3 we do this:
185 # Set VDRDIR=/usr/include/vdr
186 # Set VDRINCDIR=/usr/include
187 # Change $(VDRDIR)/include to $(VDRINCDIR)
188
189 ebegin " Setting paths"
190 sed -i Makefile \
191 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
192 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
193 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
194 \
195 -e 's:-I$(DVBDIR)/include::' \
196 -e 's:-I$(DVBDIR)::'
197 eend 0
198
199 # maybe needed for multiproto:
200 #sed -i Makefile \
201 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
202 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
203
204 if ! grep -q APIVERSION Makefile; then
205 ebegin " Converting to APIVERSION"
206 sed -i Makefile \
207 -e 's:^APIVERSION = :APIVERSION ?= :' \
208 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
209 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
210 eend $?
211 fi
212
213 # Correcting Compile-Flags
214 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
215 sed -i Makefile \
216 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
217 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
218
219 # Disabling file stripping, useful for debugging
220 sed -i Makefile \
221 -e '/@.*strip/d' \
222 -e '/strip \$(LIBDIR)\/\$@/d' \
223 -e '/@.*\$(STRIP)/d'
224
225 # Use a file instead of a variable as single-stepping via ebuild
226 # destroys environment.
227 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
228}
229
230vdr_add_local_patch() {
231 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
232 echo
233 einfo "Applying local patches"
234 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
235 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
236 done
237 fi
238}
239
240vdr_has_gettext() {
241 has_version ">=media-video/vdr-1.5.7"
242}
243
244plugin_has_gettext() {
245 [[ -d po ]]
246}
247
248vdr_i18n_convert_to_gettext() {
249 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
250
251 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
252 ewarn "Conversion to gettext disabled in ebuild"
253 return 1
254 fi
255
256 if [[ ! -x ${i18n_tool} ]]; then
257 eerror "Missing ${i18n_tool}"
258 eerror "Please re-emerge vdr"
259 die "Missing ${i18n_tool}"
260 fi
261
262 ebegin "Auto converting translations to gettext"
263 # call i18n-to-gettext tool
264 # take all texts missing tr call into special file
265 "${i18n_tool}" 2>/dev/null \
266 |sed -e '/^"/!d' \
267 -e '/^""$/d' \
268 -e 's/\(.*\)/trNOOP(\1)/' \
269 > dummy-translations-trNOOP.c
270
271 # if there were untranslated texts just run it again
272 # now the missing calls are listed in
273 # dummy-translations-trNOOP.c
274 if [[ -s dummy-translations-trNOOP.c ]]; then
275 "${i18n_tool}" &>/dev/null
276 fi
277
278 # now use the modified Makefile
279 if [[ -f Makefile.new ]]; then
280 mv Makefile.new Makefile
281 eend 0 ""
282 else
283 eend 1 "Conversion to gettext failed. Plugin needs fixing."
284 return 1
285 fi
286}
287
288vdr_i18n_disable_gettext() {
289 ebegin "Disabling gettext support in plugin"
290 # Remove i18n Target if using older vdr
291 sed -i Makefile \
292 -e '/^all:/s/ i18n//'
293 eend 0
294}
295
296vdr_i18n() {
297 if vdr_has_gettext; then
298 einfo "VDR has gettext support"
299 if plugin_has_gettext; then
300 einfo "Plugin has gettext support, fine"
301 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
302 ewarn "Please remove left over NO_GETTEXT_HACK."
303 fi
304 else
305 vdr_i18n_convert_to_gettext
306 if [[ $? != 0 ]]; then
307 eerror ""
308 eerror "Plugin will have only english OSD texts"
309 eerror "it needs manual fixing."
310 fi
311 fi
312 else
313 einfo "VDR has no gettext support"
314 if plugin_has_gettext; then
315 vdr_i18n_disable_gettext
316 fi
317 fi
318}
319
320vdr-plugin_copy_source_tree() {
321 pushd . >/dev/null
322 cp -r "${S}" "${T}"/source-tree
323 cd "${T}"/source-tree
324 cp "${WORKDIR}"/Makefile.before Makefile
325 # TODO: Fix this, maybe no longer needed
326 sed -i Makefile \
327 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
328 -e 's:^CXXFLAGS:#CXXFLAGS:' \
329 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
330 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
331 popd >/dev/null
332}
333
334vdr-plugin_install_source_tree() {
335 einfo "Installing sources"
336 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
337 insinto "${destdir}-${PV}"
338 doins -r "${T}"/source-tree/*
339
340 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
341}
342
343vdr-plugin_print_enable_command() {
344 local p_name c=0 l=""
345 for p_name in ${vdr_plugin_list}; do
346 c=$(( c+1 ))
347 l="$l ${p_name#vdr-}"
348 done
349
350 elog
351 case $c in
352 1) elog "Installed plugin${l}" ;;
353 *) elog "Installed $c plugins:${l}" ;;
354 esac
355 elog "To activate a plugin execute this command:"
356 elog "\teselect vdr-plugin enable <plugin_name> ..."
357 elog
358}
359
360
361## exported functions
362
363vdr-plugin_pkg_setup() {
364 # -fPIC is needed for shared objects on some platforms (amd64 and others)
365 append-flags -fPIC
366
367 # Where should the plugins live in the filesystem
368 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
369 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
370
371 # was /usr/lib/... some time ago
372 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
373 VDR_RC_DIR="/usr/share/vdr/rcscript"
374
375 # Pathes to includes
376 VDR_INCLUDE_DIR="/usr/include/vdr"
377 DVB_INCLUDE_DIR="/usr/include"
378
379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
380 LOCDIR="/usr/share/vdr/locale"
381
382 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
383 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
384 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
385
386 einfo "Compiling against"
387 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
388}
389
390vdr-plugin_src_util() {
391
392 while [ "$1" ]; do
393
394 case "$1" in
395 all)
396 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
397 ;;
398 all_but_unpack)
399 vdr-plugin_src_util add_local_patch patchmakefile i18n
400 ;;
401 unpack)
402 base_src_unpack
403 ;;
404 add_local_patch)
405 cd "${S}" || die "Could not change to plugin-source-directory!"
406 vdr_add_local_patch
407 ;;
408 patchmakefile)
409 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_patchmakefile
411 ;;
412 i18n)
413 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_i18n
415 ;;
416 esac
417
418 shift
419 done
420}
421
422vdr-plugin_src_unpack() {
423 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
424 eerror "Wrong use of vdr-plugin.eclass."
425 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
426 echo
427 eerror "Please report this at bugs.gentoo.org."
428 die "vdr-plugin_pkg_setup not called!"
429 fi
430 if [ -z "$1" ]; then
431 case "${EAPI:-0}" in
432 2)
433 vdr-plugin_src_util unpack
434 ;;
435 *)
436 vdr-plugin_src_util all
437 ;;
438 esac
439
440 else
441 vdr-plugin_src_util $@
442 fi
443}
444
445vdr-plugin_src_prepare() {
446 vdr-plugin_src_util all_but_unpack
447}
448
449vdr-plugin_src_compile() {
450 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
451
452 while [ "$1" ]; do
453
454 case "$1" in
455 prepare)
456 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
457 ;;
458 compile)
459 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
460 eerror "Wrong use of vdr-plugin.eclass."
461 eerror "An ebuild for a vdr-plugin will not work without"
462 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
463 echo
464 eerror "Please report this at bugs.gentoo.org."
465 die "vdr-plugin_src_unpack not called!"
466 fi
467 cd "${S}"
468
469 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
470
471 emake ${BUILD_PARAMS} \
472 ${BUILD_TARGETS} \
473 LOCALEDIR="${TMP_LOCALE_DIR}" \
474 LIBDIR="${S}" \
475 TMPDIR="${T}" \
476 || die "emake failed"
477 ;;
478 esac
479
480 shift
481 done
482}
483
484vdr-plugin_src_install() {
485 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
486 cd "${WORKDIR}"
487
488 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
489 local mname="${P}-Makefile"
490 cp "${S}"/Makefile "${mname}.patched"
491 cp Makefile.before "${mname}.before"
492
493 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
494
495 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
496 doins "${mname}.diff"
497
498 insinto "/usr/share/vdr/maintainer-data/makefile-before"
499 doins "${mname}.before"
500
501 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
502 doins "${mname}.patched"
503
504 fi
505
506
507
508 cd "${S}"
509 insinto "${VDR_PLUGIN_DIR}"
510 doins libvdr-*.so.*
511
512 # create list of all created plugin libs
513 vdr_plugin_list=""
514 local p_name
515 for p in libvdr-*.so.*; do
516 p_name="${p%.so*}"
517 p_name="${p_name#lib}"
518 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
519 done
520
521 create_header_checksum_file ${vdr_plugin_list}
522 create_plugindb_file ${vdr_plugin_list}
523
524 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
525 einfo "Installing locales"
526 cd "${TMP_LOCALE_DIR}"
527 insinto "${LOCDIR}"
528 doins -r *
529 fi
530
531 cd "${S}"
532 local docfile
533 for docfile in README* HISTORY CHANGELOG; do
534 [[ -f ${docfile} ]] && dodoc ${docfile}
535 done
536
537 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
538 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
539
540 if [[ -n ${VDR_CONFD_FILE} ]]; then
541 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
542 fi
543
544
545 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
546 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
547
548 if [[ -n ${VDR_RCADDON_FILE} ]]; then
549 insinto "${VDR_RC_DIR}"
550 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
551 fi
552}
553
554vdr-plugin_pkg_postinst() {
555 vdr-plugin_print_enable_command
556
557 if [[ -n "${VDR_CONFD_FILE}" ]]; then
558 elog "Please have a look at the config-file"
559 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
560 elog
561 fi
562}
563
564vdr-plugin_pkg_postrm() {
565 delete_orphan_plugindb_file
566}
567
568vdr-plugin_pkg_config() {
569 ewarn "emerge --config ${PN} is no longer supported"
570 vdr-plugin_print_enable_command
571}
572
573case "${EAPI:-0}" in
574 2)
575 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
576 ;;
577 *)
406EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 578 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
579 ;;
580esac

Legend:
Removed from v.1.30  
changed lines
  Added in v.1.66

  ViewVC Help
Powered by ViewVC 1.1.20